#pragma once
#include "../util/gdix.h"	// RANGE, Float
#include "../util/util.h"	// ASSERT

/**********************************
 * (Auto-)Range (aus app-plot.js) *
 **********************************/

template<class T> struct Range:public RANGE<T>{
  Range(T _a=0, T _e=0) {init(_a,_e);}
  void init(T _a=0, T _e=0) {a=_a; e=_e;}
  Range&init(const Range<T>r) {return operator=(r);}	// identisch mit Copy-Konstruktor
  bool expand(T _a, T _e) {
    bool r=false;
    if (my::isfinite(_a) && a>_a) {a=_a; r=true;}
    if (my::isfinite(_e) && e<_e) {e=_e; r=true;}
    return r;
  }
  bool expand(T a) {return expand(a,a);}
  bool expand(Range<T>r) {return expand(r.a,r.e);}
  void prepareFindRange() {init(FINF,-FINF);}
  T delta() const {return e-a;}
  operator T() const {return delta();}	// Typecast zu Elementtyp
  bool regular() const {return delta()>=0;}
  operator bool() const {return regular();}	// Typecast zu bool: Mindestens 1 expand() mit finiten Elementen seit prepare() ausgefhrt
  bool hasSpan() const {return delta()>0;}
  bool hasSpan(T aufloes) const {ASSERT(aufloes>=0); return delta()>=aufloes;}
  bool operator==(Range<T>r) const{return equals(r.a,r.e);}
  bool operator!=(Range<T>r) const{return!operator==(r);}
  bool equals(T _a, T _e) const{return a==_a && e==_e;}
  bool operator>=(Range<T>r) const {return inside(r.a,r.e);}
  bool inside(T _a, T _e) const{return a<=_a && _e<=e;}	// Enthaltensein oder gleich
  bool inside(T a) const{return inside(a,a);}
  bool operator>(Range<T>r) const {return real_inside(r.a,r.e);}	// Echtes Enthaltensein
  bool real_inside(T _a, T _e) const{return a<_a && _e<e;}
  bool real_inside(T a) const{return real_inside(a,a);}
  bool operator<=(Range<T>r) const {return super(r.a,r.e);}	// Obermenge
  bool super(T _a, T _e) const{return _a<=a && e<=_e;}
  bool operator<(Range<T>r) const {return real_super(r.a,r.e);}	// Echte Obermenge
  bool real_super(T _a, T _e) const{return _a<a && e<_e;}
// Ein (regulrer) Range kann zu einer anderen durchaus weder enthalten noch Obermenge sein.
// Die relationalen Operatoren sind daher nicht komplementr.
};

class DisplayRange:public Range<Float>{
public:
  Float aufloes;
  DisplayRange():Range<Float>(0,10),aufloes(0) {}
  void reset(bool log) {init(log?0.1F:0,10);}	// Hier niemals Unendlich-Werte!
  bool init(Float,Float);
  void usefulRange(int minimumOfTicks);
};
