#include "../main.h"
#include <cmath>	// in w2k3ddk/inc/crt/, unbedingt vor plotxy.h
#include "cplotxy.h"

/**************
 * Skalierung *
 **************/
// Kleinbuchstaben = Messdaten, Grobuchstaben = Bilddaten (Pixelkoordinaten)
// Skalierungsfunktionen MSSEN streng monoton sein! Entweder steigend oder fallend.

void LinScale::make(Float a, Float e, int A, int E) {
// Ziel: scale(a)==A und scale(e)==E
 e-=a; E-=A;	// e und E = Lnge
 if (!e || !E) return;
 f=(Float)E/e;	// Neuer Faktor = Lngenverhltnis, typisch negativ bei Y-Achsen a*f+O=A
 O=A-lrint(a*f);	// Die Compileroption /fp:fast rundet bereits richtig. Compilerabhngig!!
}

void LogScale::make(Float a, Float e, int A, int E) {
// Ziel: scale(a)==A und scale(e)==E
// a und e mssen gleiches Vorzeichen haben und !=0 sein
 if (!a) return;
 if ((e/=a)<=0) return;	// e = Quotient
 if (!(E-=A)) return;	// E = Lnge, bei Y-Achsen zumeist negativ
 neg=a<0;
// f*log(a)+O==A && f*log(e)+O==E
// O == A-f*log(a) == E-f*log(e)
// E-A == f*log(e)-f*log(a) == f* (log(e)-log(a)) == f* log(e/a)
 f=Float(E)/log(e);
 if (neg) a=-a;
 O=A-lrint(log(a)*f);
}

int LogScale::operator()(Float v) const{
 if (neg) v=-v;
 return lrint(f*log(v))+O;
}

Float LogScale::unscale(int V) const{
 Float v=exp(Float(V-O)/f);
 if (neg) v=-v;
 return v;
}
