#pragma once
#include "../util/gdix.h"	// Float, Point, Rect
#include "../util/cstr.h"	// cstr<>


TCHAR toUnitPrefix(Float&x,Float aufloes=0,WORD allow=0xFFFF);	// LOBYTE = yokto..milli, HIBYTE = kilo..Yotta
Float roundToMultiple(Float x, Float mult);	// mult<0: abrunden, mult>0: aufrunden, mult==0: Nicht erlaubt
Float roundToLog(Float x, Float base);		// base<0: abrunden, base>0: aufrunden, base==0: Nicht erlaubt
Float roundWithMethod(Float x,DWORD flags,char dir=1);


struct MINORTICK{
 Float p;		// Achsenposition, niemals Inf/NaN
 int xy;		// via ax.scale() umgerechnetes <p>, je nach Achsenrichtung x oder y
};

struct MAJORTICK:public MINORTICK{
 cstr<> text;		// Angezeigter Text (Konstruktor generiert Pointer auf Nullbyte)
 char importance;	// Wichtigkeit, kleinere Werte fhren zum Weglassen des Labels
 char align;		// ungenutzt
 Point<char>adjust;	// ungenutzt
//  MAJORTICK(Float p,const TCHAR*t,char i):MINORTICK(p),text(const_cast<TCHAR*>(t)),importance(i) {}
//  MAJORTICK() {}
};

class Axis;

class Tick:public MAJORTICK{
 Axis&ax;		// Fr Rckbezug
 Point<>anker;		// Textanker, lokal zum Achsenrechteck
 Rect<>ta;		// Textrechteck, lokal zum Achsenrechteck
 void makeText();	// erstellt Text (hat jeder Tick einen Text??)
public:
 Tick(const MAJORTICK&);
 Tick(Axis&a,Float p,const TCHAR*t=0,char i=0);
 void update();
 int getXY() {update(); return xy;}
 const TCHAR*getText() {makeText(); return text;}
 const Point<>&getAnker() {update(); return anker;}
 const Rect<>&getRect() {update(); return ta;}
 void invalidate() {adjust.x=0;}	// Aufrufen wenn sich irgendwelche Mae ndern!
};

