#pragma once

// vergleichbar basic_string, Pascal-String, ohne Exceptions
// mit Kapazittsfestlegung zur Compilezeit
template<class T,size_t MAX,class TL=size_t> class fixvec{
 TL fill;
 T a[MAX];
 enum{capa=MAX};
public:
 typedef T* iterator;
 typedef const T* const_iterator;
 typedef T& reference;
 typedef const T& const_reference;
 fixvec(TL sz=0):fill(sz) {for(TL i=0;i<fill;i++)new(a[i])T();}	// Elemente default-konstruieren
 fixvec(TL sz,bool z):fill(sz) {if(z)memset(a,0,sz*sizeof(T));}	// Elemente uninitialisiert oder Null
 ~fixvec() {clear();}						// Elemente rckwrts abbauen
 TL size() const {return fill;}
 static TL capacity() {return capa;}
 static bool reserve(TL sz) {return sz<=capa;}
 bool resize(TL sz) {if(sz>capa)return false;if(fill>sz)return commit(sz,false);while(fill<sz)new(a[fill++])T(); return true;}
 bool commit(TL sz,bool z) {if(sz>capa)return false;while(fill>sz)a[--fill].~T();if(z)memset(a+fill,0,(sz-fill)*sizeof(T));fill=sz;return true;}
 iterator begin() {return a;}
 const_iterator begin() const {return a;}
 iterator end() {return a+fill;}
 const_iterator end() const {return a+fill;}
 T*data() {return a;}
 const T*data() const {return a;}
 reference operator[](TL i) {if(i<0)i+=fill;return a[i];}
 const_reference operator[](TL i) const {if(i<0)i+=fill;return a[i];}
 reference front() {return a[0];}
 const_reference front() const{return a[0];}
 reference back() {return a[fill-1];}
 const_reference back() const{return a[fill-1];}
 reference at(TL i) {if(i<0)i+=fill;return(size_t)i<(size_t)fill?a[i]:*(T*)0;}
 const_reference at(TL i) const {if(i<0)i+=fill;return(size_t)i<(size_t)fill?a[i]:*(const T*)0;}
 void clear() {commit(0,false);}
 bool push_back(const T&el) {return insert(a+fill,el);}
 bool insert(iterator it,const T&el) {if(fill>=capa)return false;memmove(it+1,it,(a+fill-it)*sizeof(T));*it=el;++fill;return true;}
 bool insert(TL i,const T&el) {if(i<0)i+=fill;return(size_t)i<=(size_t)fill&&insert(a+i,T);}
 void erase(iterator it) {it->~T();--fill;memmove(it,it+1,(a+fill-it)*sizeof(T));}
 bool erase(TL i) {if(i<0)i+=fill;return(size_t)i<(size_t)fill&&erase(a+i);}
// Die indexbasierten Funktionen verdauen auch negative Indizes, wenn TL ein vorzeichenbehafteter Typ ist
};


// Ein std::vector-hnliches Konstrukt, nicht resizeable
// mit Kapazittsfestlegung beim Erstellen (bspw. auf dem Stack)
template<class T,class TL=size_t>class fix_vector{
protected:
 T*a;
 TL fill,capa;
 void(*pfree)(void*);
public:
 typedef T* iterator;
 typedef const T* const_iterator;
 typedef T& reference;
 typedef const T& const_reference;
 fix_vector(void*buf,TL sz):a((T*)buf),fill(0),capa(sz),pfree(0) {}
 fix_vector(TL sz):a((T*)_alloca(sz*sizeof(T))),fill(0),capa(sz),pfree(0) {}
 fix_vector(TL sz,bool):a((T*)malloc(sz*sizeof(T))),fill(0),capa(sz),pfree(free) {}
 ~fix_vector() {clear();if(pfree)pfree(a);}
 TL size() const{return fill;}
 TL capacity() const{return capa;}
 bool reserve(TL sz) {return sz<=capa;}
 bool resize(TL sz) {if(sz>capa)return false;if(fill>sz)return commit(sz,false);while(fill<sz)new(a[fill++])T();return true;}
 bool commit(TL sz,bool z) {if(sz>capa)return false;while(fill>sz)a[--fill].~T();if(z)memset(a.fill,0,(sz-fill)*sizeof(T);fill=sz;return true;}
 iterator begin() {return a;}
 const_iterator begin() const{return a;}
 iterator end() {return a+fill;}
 const_iterator end() const{return a+fill;}
 T*data() {return a;}
 const T*data() const {return a;}
 reference operator[](TL i) {if(i<0)i+=fill;return a[i];}
 const_reference operator[](TL i) const{if(i<0)i+=fill;return a[i];}
 const_reference front() const{return a[0];}
 reference back() {return a[fill-1];}
 const_reference back() const{return a[fill-1];}
 reference at(TL i) {if(i<0)i+=fill;return(size_t)i<(size_t)fill?a[i]:*(T*)0;}
 const_reference at(TL i) const {if(i<0)i+=fill;return(size_t)i<(size_t)fill?a[i]:*(const T*)0;}
 void clear() {commit(0,false);}
 bool push_back(const T&el) {return insert(a+fill,el);}
 bool insert(iterator it,const T&el) {if(fill>=capa)return false;memmove(it+1,it,(a+fill-it)*sizeof(T));*it=el;++fill;return true;}
 bool insert(TL i,const T&el) {if(i<0)i+=fill;return(size_t)i<=(size_t)fill&&insert(a+i,T);}
 void erase(iterator it) {it->~T();--fill;memmove(it,it+1,(a+fill-it)*sizeof(T));}
 bool erase(TL i) {if(i<0)i+=fill;return(size_t)i<(size_t)fill&&erase(a+i);}
};
